#include <iostream>
#include <map>
#include <string>

// Custom comparator for descending order of keys
struct DescendingOrder {
    bool operator()(const std::string& a, const std::string& b) const {
        return a > b;
    }
};

int main() {
    std::multimap<std::string, int, DescendingOrder> fruitInventory;

    fruitInventory.insert({"Apple", 100});
    fruitInventory.insert({"Banana", 150});
    fruitInventory.insert({"Cherry", 75});
    fruitInventory.insert({"Apple", 120});  // Another entry for Apple
    fruitInventory.insert({"Banana", 130}); // Another entry for Banana

    for (const auto& pair : fruitInventory) {
        std::cout << pair.first << ": " << pair.second << std::endl;
    }

    return 0;
}
